package org.example;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.data.jpa.repository.Query;

public interface TrackRepository extends JpaRepository<Track, Integer> {

    @Query("""
            SELECT new org.example.TrackRecord(t.name, a.title, t.compser)
            FROM Track t
            JOIN Album a On t.album.albumId=a.albumId
            WHERE t.trackId = :id
            """)
    TrackRecord findTrackRecord(@Param("id") Integer trackId);

}
