package org.example;

import jakarta.persistence.EntityManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class TrackService {
    @Autowired
    TrackRepository repository;

    @Autowired
    EntityManager entityManager;

    @Transactional(readOnly = true)
    public TrackRecord getTrackRecord(Integer trackId) {
        Track track = repository.findById(trackId).get();
        TrackRecord trackRecord = new TrackRecord(
                track.getName(),
                track.getAlbum().getTitle(),
                track.getComposer());
        return trackRecord;
    }

    @Transactional(readOnly = true)
    public TrackRecord getTrackRecord1(Integer trackId) {
        org.hibernate.query.Query<TrackRecord> query = entityManager.createQuery(
                """
                            SELECT t.name, a.title, t.composer
                            FROM Track t
                            JOIN Album a ON t.album.albumId=a.albumId
                            WHERE t.trackId=:id
"""
        ).setParameter("id", trackId).unwrap(org.hibernate.query.Query.class);

        TrackRecord trackRecord = query.setTupleTransformer((tuple, aliases) -> {
            return new TrackRecord(
                    (String) tuple[0],
                    (String) tuple[1],
                    (String) tuple[2]);
        }).getSingleResult();
        return trackRecord;
    }

    @Transactional(readOnly = true)
    public TrackRecord getTrackRecord2(Integer trackId) {
        return repository.findTrackRecord(trackId);
    }
}